/*
 * Simple packet capturing and network monitoring tool.
 * 
 * etherprot.c - function for determining the hardware-
 *               layer protocol.
 *
 * Written by Alexander Hauser
 * lex@lufix.net
 * http://www.lufix.net/
 * http://www.sac.cc/
 *
 * */

#include "nsniff.h"

void scanEtherProt(uint16_t proto) {
	const char nofunc[45] =
		"no function for that protocol implemented.";
	
	switch (proto) {
		case 0x0400:
			printf("Nixdorf protocol. %s.", nofunc);
			break;
		case 0x0601:
			printf("XNS Address Translation. %s.", nofunc);
			break;
		case 0x0801:
			printf("X.75 Internet. %s.", nofunc);
			break;
		case 0x0802:
			printf("NBS Internet. %s.", nofunc);
			break;
		case 0x0803:
			printf("ECMA Internet. %s.", nofunc);
			break;
		case 0x0804:
			printf("CHAOSnet. %s.", nofunc);
			break;
		case 0x0805:
			printf("X.25 Level 3. %s.", nofunc);
			break;

		default:
			printf("unknown transport-layer protocol. skipping.");
			break;
	}
	return;
}

