/*
 * Simple packet capturing and network monitoring tool.
 * 
 * nsniff.c - contains the main program.
 *
 * Written by Alexander Hauser
 * lex@lufix.net
 * http://www.lufix.net/
 * http://www.sac.cc/
 *
 * */

#include "nsniff.h"

int main(int argc, char **argv) {
	int c, on=1, i;
	char *ptr, localname[1024];
	 
	snaplen = SNAPLEN;
	opterr = 0;
	while ((c = getopt(argc, argv, "eicmnrvh")) != -1) {
		switch (c) {
			case 'v':
				verbose++;
				break;
			 
			case 'i':
				device = argv[optind++];
				break;
			 
			case 'c':
				if (!(counto = atoi(argv[optind++]))) {
					printf("type: -c <COUNT>\n");
					exit(1);
				}
				break;
				
			case 'e':
				etherp++;
				break;
			 
			case 'm':
				if (!argv[optind]) {
					printf("type: -m <BYTES>\n");
					exit(1);
				}
				if (!(snaplen = atoi(argv[optind++]))) {
					printf("wrong format. type: -m <BYTES>\n");
					exit(1);
				}
				break;
				
			case 'n':
				names++;
				break;
			 
			case 'r':
				procraw++;
				break;
			 
			case 'h':
				banner();
				usage("");
				break;
			 
			case '?':
				usage("unrecognized option");
		}
	}
	if (optind < argc) {
		bzero(&compstr, sizeof(compstr));
		compile++;
		compstr = copy_argv(&argv[optind]);
	}
	banner();
	 
	signal(SIGINT, cleanup);
	signal(SIGTERM, cleanup);
	signal(SIGHUP, cleanup);
	open_pcap();
	readloop();
	 
	exit(0);
}

