/*
 * Simple packet capturing and network monitoring tool.
 * 
 * proc_arp.c - function for processing the ARP protocol.
 *
 * Written by Alexander Hauser
 * lex@lufix.net
 * http://www.lufix.net/
 * http://www.sac.cc/
 *
 * */

#include "nsniff.h"

void arp_process(char *ptr, uint8_t sender[ETH_ALEN], uint8_t target[ETH_ALEN]) {
	struct ether_arp *earp;
	int i;
	 
	earp = (struct ether_arp *) ptr;
	switch (ntohs(earp->ea_hdr.ar_op)) {
		case ARPOP_REQUEST:
			printf("ARP-REQUEST: who has %d.%d.%d.%d tell ", earp->arp_tpa[0], earp->arp_tpa[1],
				earp->arp_tpa[2], earp->arp_tpa[3]);
			for (i=0; i<4; i++) printf("%d.", earp->arp_spa[i]);
			break;
		case ARPOP_REPLY:
			printf("ARP-REPLY: %d.%d.%d.%d is at ", earp->arp_spa[0], earp->arp_spa[1],
				earp->arp_spa[2], earp->arp_spa[3]);
			switch (ntohs(earp->ea_hdr.ar_hrd)) {
				case ARPHRD_ETHER:
					print_etheradrs(earp->arp_sha, 0);
					break;
			}
			break;
	}
	if (verbose) {
		switch (ntohs(earp->ea_hdr.ar_hrd)) {
			case ARPHRD_ETHER:
				printf(" (");
				print_etheradrs(earp->arp_sha, earp->arp_tha);
				printf(")");
				break;
		}
	}				
	 
	return;
}
