/*
 * Simple packet capturing and network monitoring tool.
 * 
 * proc_dns.c - function for processing the DNS protocol.
 *
 * Written by Alexander Hauser
 * lex@lufix.net
 * http://www.lufix.net/
 * http://www.sac.cc/
 *
 * */

#include "nsniff.h"

void dns_process(char *ptr) {
	struct dns_header dns;
	int i;
	 
	memcpy(&dns, ptr, 12);
	dns.flags = ntohs(dns.flags);
	printf("\n");
	printf("DNS. ");
	printf("<");
	if (dns.flags & (1<<15))	/* QR bit */
		printf("REPLY");
	else
		printf("QUERY");
	 
	if (dns.flags & (1<<11))	/* opcode */
		printf("/IQUERY");
	else if ((dns.flags&(1<<12)) && !(dns.flags&(1<<11)))
		printf("/STATUS");
	 
	if (dns.flags & (1<<10))	/* AA bit */
		printf("/AA");
	if (dns.flags & (1<<9))		/* TC bit */
		printf("/TC");
	if (dns.flags & (1<<8))		/* RD bit */
		printf("/RD");
	if (dns.flags & (1<<7))		/* RA bit */
		printf("/RA");
		
	/* rcode field */
	if ((dns.flags&(1<<0)) && !(dns.flags&(1<<1)) && !(dns.flags&(1<<2)))	/* dec 1 */
		printf("/FormErr");
	if (!(dns.flags&(1<<0)) && (dns.flags&(1<<1)) && !(dns.flags&(1<<2)))	/* dec 2 */
		printf("/ServFail");
	if ((dns.flags&(1<<0)) && (dns.flags&(1<<1)) && !(dns.flags&(1<<2)))	/* dec 3 */
		printf("/NameErr");
	if (!(dns.flags&(1<<0)) && !(dns.flags&(1<<1)) && (dns.flags&(1<<2)))	/* dec 4 */
		printf("/NotImpl");
	if (!(dns.flags&(1<<0)) && !(dns.flags&(1<<1)) && (dns.flags&(1<<2)))	/* dec 5 */
		printf("/Refused");
	 
	printf(">; ");
	printf("ID: %d; questions: %d; answer-RRs: %d; authority-RRs: %d; additional-RRs: %d",
		ntohs(dns.id), ntohs(dns.numquest), ntohs(dns.numrr),
		ntohs(dns.numarr), ntohs(dns.numadrr));
	 
	return;
}
