/*
 * Simple packet capturing and network monitoring tool.
 * 
 * proc_tcp.c - function for processing the TCP header.
 *
 * Written by Alexander Hauser
 * lex@lufix.net
 * http://www.lufix.net/
 * http://www.sac.cc/
 *
 * */

#include "nsniff.h"

/* processes the tcp header */
void *tcp_process(char *ptr, int len) {
	struct tcphdr *tcp;
	struct servent *sptr;
	int hlen = sizeof(struct tcphdr);
	
	tcp = (struct tcphdr *) ptr;
	printf("\nProtocol: TCP. PORTS: ");
	if (names) {
		if ((sptr = getservbyport(tcp->source, "tcp")) == NULL)
			printf("%d >> ", ntohs(tcp->source));
		else
			printf("%s >> ", sptr->s_name);
		if ((sptr = getservbyport(tcp->dest, "tcp")) == NULL)
			printf("%d , ", ntohs(tcp->dest));
		else
			printf("%s , ", sptr->s_name);
	} else																														
	printf("%d >> %d, ", ntohs(tcp->source), ntohs(tcp->dest));
		
	if (tcp->ack == 1)
		printf("ACK, ");
	if (tcp->syn == 1)
		printf("SYN, ");
	if (tcp->fin == 1)
		printf("FIN, ");
	if (tcp->rst == 1)
		printf("RST, ");
	if (tcp->psh == 1)
		printf("PSH, ");
	if (tcp->urg == 1)
		printf("URG, ");
	 
	if (verbose)
		printf("SEQ: %d, ACK_SEQ: %d, ", ntohs(tcp->seq), ntohs(tcp->ack_seq));
	printf("WINDOW: %d", ntohs(tcp->window));
	 
	checkport(ntohs(tcp->source), ntohs(tcp->dest), ptr+sizeof(struct tcphdr));
	 
		
	return;
}

